﻿using System;
using System.Runtime.InteropServices;
 
namespace TestProject
{
    /// <summary>
    /// WIN32 API 헬퍼
    /// </summary>
    public static class WIN32APIHelper
    {
        //////////////////////////////////////////////////////////////////////////////////////////////////// Import
        ////////////////////////////////////////////////////////////////////////////////////////// Static
        //////////////////////////////////////////////////////////////////////////////// Private

        #region 표준 핸들 구하기 - GetStdHandle(standardDevice)

        /// <summary>
        /// 표준 핸들 구하기
        /// </summary>
        /// <param name="standardDevice">표준 장치</param>
        /// <returns>표준 핸들</returns>
        /// <remarks>
        /// STD_INPUT_HANDLE  : -10
        /// STD_OUTPUT_HANDLE : -11
        /// STD_ERROR_HANDLE  : -12
        /// </remarks>
        [DllImport("Kernel32.dll")]
        private static extern IntPtr GetStdHandle(int standardDevice);

        #endregion
        #region 콘솔 텍스트 어트리뷰트 설정하기 - SetConsoleTextAttribute(consoleOutputHandle, attribute)

        /// <summary>
        /// 콘솔 텍스트 어트리뷰트 설정하기
        /// </summary>
        /// <param name="consoleOutputHandle">콘솔 출력 핸들</param>
        /// <param name="attribute">어트리뷰트</param>
        /// <returns>처리 결과</returns>
        [DllImport("Kernel32.dll")]
        private static extern int SetConsoleTextAttribute(IntPtr consoleOutputHandle, short attribute);

        #endregion

        //////////////////////////////////////////////////////////////////////////////////////////////////// Field
        ////////////////////////////////////////////////////////////////////////////////////////// Private

        #region Field

        /// <summary>
        /// STD_OUTPUT_HANDLE
        /// </summary>
        private const int STD_OUTPUT_HANDLE = -11;

        #endregion

        //////////////////////////////////////////////////////////////////////////////////////////////////// Method
        ////////////////////////////////////////////////////////////////////////////////////////// Static
        //////////////////////////////////////////////////////////////////////////////// Public

        #region 콘솔 텍스트 색상 설정하기 - SetConsoleTextColor(color)

        /// <summary>
        /// 콘솔 텍스트 색상 설정하기
        /// </summary>
        /// <param name="color">색상</param>
        public static void SetConsoleTextColor(ConsoleTextColor color)
        {
            IntPtr handle = GetStdHandle(STD_OUTPUT_HANDLE);

            SetConsoleTextAttribute(handle, (short)color);
        }

        #endregion
    }
}